/* SPDX-License-Identifier: GPL-2.0 */
/*
 * Copyright (C) 2020 Loongson Technology Co., Ltd.
 */
#ifndef _ASM_LOONGARCH_EFI_H
#define _ASM_LOONGARCH_EFI_H
#include <linux/efi.h>
extern void __init efi_init(void);
extern void __init efi_runtime_init(void);

#define ARCH_EFI_IRQ_FLAGS_MASK  0x00000001  /*bit0: CP0 Status.IE*/

static inline void efifb_setup_from_dmi(struct screen_info *si, const char *opt)
{
}

#define arch_efi_call_virt_setup()               \
({                                               \
})

#define arch_efi_call_virt(p, f, args...)        \
({                                               \
	efi_##f##_t * __f;                       \
	__f = p->f;                              \
	__f(args);                               \
})

#define arch_efi_call_virt_teardown()            \
({                                               \
})

#define efi_call_early(f, ...)		sys_table_arg->boottime->f(__VA_ARGS__)
#define __efi_call_early(f, ...)	f(__VA_ARGS__)
#define efi_call_runtime(f, ...)	sys_table_arg->runtime->f(__VA_ARGS__)
#define efi_is_64bit()			(true)

#define efi_table_attr(table, attr, inst) (inst->attr)

#define efi_call_proto(protocol, f, instance, ...)			\
	(((protocol##_t *)instance)->f(instance, ##__VA_ARGS__))

#define EFI_ALLOC_ALIGN		SZ_16K

static inline unsigned long efi_get_max_addr(void)
{
	uint64_t addr;
	int pabits = (read_cpucfg(LOONGARCH_CPUCFG1) & CPUCFG1_PABITS) >> 4;

	asm volatile ("csrrd %0, 0x181" : "=r" (addr));
	return addr |= (1UL << pabits) - 1;
}
#endif /* _ASM_LOONGARCH_EFI_H */
